#include <windows.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

typedef struct{
	char szAppName[50];
   char szDescrName[50];
   char exec[50];
}APPLINFO;

char *lpBuf = "        "
					" ,     "
               " ";

LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

int CALLBACK LVCompareProc(LPARAM lParam1, LPARAM lParam2,
LPARAM lParamSort);

APPLINFO rgApplInfo[] = {
	{"Animation Control", " ", "animation.exe"},
   {"Drag List Box",     "  ", "draglist.exe"},
   {"Header Control",    " ", "header.exe"},
   {"Hot-key Control",   "  ", "hot-key.exe"},
	{"Image List",        " ", "imagelist.exe"},
   {"List View Control", " ", "listview.exe"},
   {"Progress Bar",      "", "progressbar.exe"},
   {"Property Sheet",    " ", "propertysheet.exe"},
   {"Rich Edit Control", "    ", "richedit.exe"},
   {"Status Window",     " ", "statusbar.exe"},
   {"Tab Control",       "", "tabcontrol.exe"},
   {"ToolBar",           " ", "toolbar.exe"},
   {"ToolTip Control",   " ", "tooltip.exe"},
   {"Trackbar",          "", "trackbar.exe"},
   {"Tree View Control", " ", "treeview.exe"},
   {"Up-Down Control",   "", "spin.exe"},
};

//  
char const szClassName[] = "CommonControls";
// 
char const szWindowTitle[] = "  ";

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "MIN_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON, 16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	int i, ind;
   RECT rc;
   LV_COLUMN lvc;
   LV_ITEM lvi;
   static HWND hwndListView;
   LV_DISPINFO * lpLvdi;
   APPLINFO * lpAppinfo;

	switch (Message){

		case WM_CREATE:
      	GetClientRect(hWnd, &rc);
         hwndListView = CreateWindow(WC_LISTVIEW, "",
         					WS_VISIBLE | WS_CHILD | WS_BORDER | LVS_REPORT |
                        LVS_SINGLESEL, 0, 0, rc.right-rc.left, rc.bottom-rc.top,
                        hWnd, (HMENU)IDC_LISTVIEW, hInst, NULL);
         if(hwndListView == NULL) return FALSE;

         memset(&lvc, 0, sizeof(lvc));
         lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
         lvc.fmt = LVCFMT_LEFT;

         lvc.cx = (rc.right-rc.left)/3;
         lvc.iSubItem = 0;
         lvc.pszText = "Common Controls";
         ListView_InsertColumn(hwndListView, 0, &lvc);

         lvc.cx = (rc.right-rc.left)/3*2;
         lvc.iSubItem = 1;
         lvc.pszText = "Description";
         ListView_InsertColumn(hwndListView, 1, &lvc);

         memset(&lvi, 0, sizeof(lvi));
         lvi.mask = LVIF_TEXT | LVIF_PARAM;
         lvi.pszText = LPSTR_TEXTCALLBACK;// pszText  
         									//   LVN_GETDISPINFO

         for (i=0; i<16; i++){
	         lvi.iItem = i;
   	      lvi.iSubItem = 0;
      	   lvi.cchTextMax = 50;
         	lvi.lParam = (LPARAM)&rgApplInfo[i];
            ListView_InsertItem(hwndListView, &lvi);

            lvi.iItem = i;
            lvi.iSubItem = 1;
            ListView_InsertItem(hwndListView, &lvi);
         }
         return 0;

      case WM_COMMAND:
         switch(LOWORD(wParam)){

	         case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_INDEX, NULL);
					break;

				case IDM_EXIT:
					PostQuitMessage(0);
					break;
         }
      	return 0;

      case WM_NOTIFY:
         lpLvdi = (LV_DISPINFO *)lParam;
         lpAppinfo = (APPLINFO *)(lpLvdi->item.lParam);
         if(((NMHDR *)lParam)->idFrom != IDC_LISTVIEW) return 0L;
         switch(((NMHDR *)lParam)->code){

         	case NM_DBLCLK:
               	ind = ListView_GetNextItem(hwndListView, -1, LVNI_SELECTED);
                  if (ind == -1) return 0;
                  WinExec(rgApplInfo[ind].exec, SW_SHOWNORMAL);
            	break;

         	case LVN_GETDISPINFO:
            	if(lpLvdi->item.mask & LVIF_TEXT){
               	switch(lpLvdi->item.iSubItem){
                  	case 0:
                     	lpLvdi->item.pszText = lpAppinfo->szAppName;
                        break;

                     case 1:
                     	lpLvdi->item.pszText = lpAppinfo->szDescrName;
                        break;

                     default:
                     	break;
                  }
               }
               break;

			}
      	return 0;

      case WM_SIZE:

      	MoveWindow(hwndListView, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
         return 0;

      case WM_DESTROY:

         DestroyWindow(hwndListView);
			PostQuitMessage(0);
			return 0;
	}
   //      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC1, "  ");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

