/*
animation.cpp
      Animation

 :
    ,  
  .  ""   ,
 ""  .     
   .
*/

#include <windows.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "    ,  "
              "   .  \"\"  "
              " ,  \"\"  . "
              "        "
              ".";

LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

//  
char const szClassName[] = "AnimationControl";
// 
char const szWindowTitle[] = "  :  ";

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH); //  
	WndClass.lpszMenuName = "ACM_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   							IMAGE_ICON, 16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  250, 150, // ,  
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
   static HWND hwndAnim;
   static HMENU hwndMenu;
   static RECT rc;

	switch (Message)
	{
		case WM_CREATE:
         hwndMenu = GetMenu(hWnd);
         GetClientRect(hWnd, &rc);

         //    Animation
      	hwndAnim = Animate_Create(hWnd, IDC_ANIMATE,
         			  WS_BORDER | WS_CHILD |
                    ACS_TRANSPARENT | ACS_CENTER, hInst);
         if (!hwndAnim)
         	return FALSE;

         SetWindowPos(hwndAnim, 0,
         	0, 0,
            rc.right, rc.bottom,
            SWP_NOZORDER | SWP_DRAWFRAME);

         // AVI-  
         Animate_Open(hwndAnim, IDC_AVI);
         // Animate_Open(hwndAnim, "dillo.avi");

         ShowWindow(hwndAnim, SW_SHOW);
        return TRUE;

      case WM_COMMAND:
         switch(LOWORD(wParam)){

         	case IDM_START:
            	// 
            	Animate_Play(hwndAnim, 0, -1, -1);
               EnableMenuItem(hwndMenu, IDM_STOP, MF_BYCOMMAND | MF_ENABLED);
               EnableMenuItem(hwndMenu, IDM_START, MF_BYCOMMAND | MF_DISABLED);
               break;

            case IDM_STOP:
            	// 
            	Animate_Stop(hwndAnim);
               EnableMenuItem(hwndMenu, IDM_STOP, MF_BYCOMMAND | MF_DISABLED);
               EnableMenuItem(hwndMenu, IDM_START, MF_BYCOMMAND | MF_ENABLED);
               break;

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_animation);
					break;

				case IDM_EXIT:
					PostQuitMessage(0);
					break;
         }
      	return TRUE;

      case WM_DESTROY:

         PostQuitMessage(0);
			return TRUE;
	}
   //      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Animation");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

