/*
draglist.cpp
      Drag List Box

 :
   ""   ,   
,        ,
         
*/

#include <windows.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "   \"\"   , "
				  "   ,     "
              "   ,     "
              "     ";

BOOL CALLBACK DragListDialogProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

//  
char const szClassName[] = "DragListControl";
// 
char const szWindowTitle[] = "  :   ";

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "PROC_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   							IMAGE_ICON, 16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{

	switch (Message)
	{

      case WM_COMMAND:
         switch(LOWORD(wParam)){

         	case IDM_DIALOG:
            	DialogBox((HINSTANCE)hInst, "DragListDialog",
               			 hWnd, (DLGPROC)DragListDialogProc);
               InvalidateRect(hWnd, NULL, TRUE);
               break;

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_draglist);
					break;

				case IDM_EXIT:
					PostQuitMessage(0);
					break;
         }
      	return TRUE;

      case WM_DESTROY:
         PostQuitMessage(0);
			return TRUE;
	}
   //      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}

#pragma argsused
BOOL CALLBACK DragListDialogProc(HWND hDlg, UINT Message,
										   WPARAM wParam, LPARAM lParam){

 static HWND hwndDragList; // Drag List Box
 static UINT uDragMessage; //    ,
 									//  Drag List Box  
 static char buf[20], lpsz[15][20] =
	{"", "", "", "", "",
	 "", "", "", "", "",
  	 "", "", "", "", ""};
 int i;
 static DRAGLISTINFO * lpdli;
 static int index;

 //    Drag List Box
 if (uDragMessage == Message){

   	lpdli = (DRAGLISTINFO*)lParam;

      switch(lpdli->uNotification){
         // 
      	case DL_BEGINDRAG:
         	//      
         	index = LBItemFromPt(hwndDragList, lpdli->ptCursor, TRUE);

            // ,     index
            SendMessage(hwndDragList, LB_GETTEXT, index, (LPARAM)buf);

            //    
            DrawInsert(hDlg, hwndDragList, index);
            return TRUE;

/*
				case DL_DRAGGING:
         	DrawInsert(hDlg, hwndDragList,
            			  LBItemFromPt(hwndDragList, lpdli->ptCursor, TRUE));
            return DL_MOVECURSOR;
*/

			// 
         case DL_DROPPED:

         	//   
            SendMessage(hwndDragList, LB_DELETESTRING, index, 0);

            //   
            index = LBItemFromPt(hwndDragList, lpdli->ptCursor, TRUE);

            //    
            SendMessage(hwndDragList, LB_INSERTSTRING, index, (LPARAM)buf);
         	break;
      }
      return TRUE;
 };

 switch(Message){

	case WM_INITDIALOG:

      //   List Box
   	hwndDragList = GetDlgItem(hDlg, IDC_DRAGLISTBOX);

      //   List Box  Drag List Box
      MakeDragList(hwndDragList);

      //   
		for(i=0; i<15; i++)
        	SendMessage(hwndDragList, LB_ADDSTRING, 0, (LPARAM)lpsz[i]);

      // ,     Drag List Box
		//    
      uDragMessage = RegisterWindowMessage(DRAGLISTMSGSTRING);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
         case IDCANCEL:
         	EndDialog(hDlg, 0);
            return FALSE;
      }
      break;
 }
 return FALSE;
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Drag List Box");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

