/*
header.cpp
      Header

 :
      ,    
  bitmap',  - .
*/

#include <windows.h>
#include <commctrl.h>
#include <mmsystem.h>

#include "proc.h"   //    
						  //

char *lpBuf = "      ,   "
				  "    bitmap',  - .";

LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

//  
char const szClassName[] = "HeaderControl";
// 
char const szWindowTitle[] = "  :  ";

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "MIN_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   							IMAGE_ICON, 16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
   static HWND hwndHeader;
   RECT rcParent;
   HD_LAYOUT hdl;
   static WINDOWPOS wp;
   HD_ITEM hdi;
   DWORD iInsertAfter;
   char *lpsz[] = {"item #1", "item #2", "item #3", "item #4"};
   int i;
   HD_NOTIFY *hdn;

	switch (Message)
	{
		case WM_CREATE:

      	//   Header
      	if ((hwndHeader = CreateWindowEx(0, WC_HEADER, (LPCTSTR) NULL,
                WS_CHILD | WS_BORDER | HDS_BUTTONS | HDS_HORZ,
                0, 0, 0, 0, hWnd, (HMENU) ID_HEADER, hInst,
                (LPVOID) NULL)) == NULL)
         	return 0;

			GetClientRect(hWnd, &rcParent);

			hdl.prc = &rcParent;
			hdl.pwpos = &wp;
			if (!SendMessage(hwndHeader, HDM_LAYOUT, 0, (LPARAM)&hdl))
         	return 0;

         // ,      Header
			SetWindowPos(hwndHeader, wp.hwndInsertAfter, wp.x, wp.y,
            wp.cx, wp.cy, wp.flags | SWP_SHOWWINDOW);

         iInsertAfter = 0;

         hdi.mask = HDI_BITMAP | HDI_FORMAT | HDI_WIDTH;
			hdi.hbm = (HBITMAP)LoadBitmap(hInst, MAKEINTRESOURCE(IDB_HDBITMAP));

			hdi.cxy = wp.cx/5;
			hdi.fmt = HDF_CENTER | HDF_BITMAP;

         iInsertAfter = SendMessage(hwndHeader, HDM_INSERTITEM,
         				(WPARAM)iInsertAfter, (LPARAM)&hdi);

         for(i=0; i<4; i++){
   			hdi.mask = HDI_TEXT | HDI_FORMAT | HDI_WIDTH;
				hdi.pszText = lpsz[i];

				hdi.cchTextMax = lstrlen(hdi.pszText);
				hdi.fmt = HDF_LEFT | HDF_STRING;

            //   wParam   0,  
            //   
            //   >  =   ,
            //     
				iInsertAfter = SendMessage(hwndHeader, HDM_INSERTITEM,
         				(WPARAM)iInsertAfter+1, (LPARAM)&hdi);
			}

         return 0;

      case WM_SIZE:
         MoveWindow(hwndHeader, 0, 0, LOWORD(lParam), wp.cy, TRUE);
      	break;

      case WM_NOTIFY:
         hdn = (HD_NOTIFY *)lParam;
         switch (hdn->hdr.code){
         	case HDN_ITEMCLICK:
               if (hdn->iItem == 0)
               	sndPlaySound("train.wav", SND_SYNC);
            	break;
         }
      	break;

      case WM_COMMAND:
         switch(LOWORD(wParam)){

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_header);
					break;

				case IDM_EXIT:
					PostQuitMessage(0);
					break;
         }
      	return TRUE;

      case WM_DESTROY:

         PostQuitMessage(0);
			return TRUE;
	}
   //      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Header");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

