/*
hot-key.cpp
      Hot-Key

 :
      ,  
        " ...".  
 Hot-Key ( "")      .
*/

#include <windows.h>                
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "      "
				  ",       "
				  "    \" ...\".    "
              "Hot-Key ( \"\")      "
              ".";

BOOL APIENTRY HotKeyDlgProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam);

LRESULT CALLBACK WndProc
	  (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam);

//  
char const szClassName[] = "HotKeyControl";
// 
char const szWindowTitle[] = "  :  ";

HWND hwndHotKey;
HWND hwndMainWindow;
WORD wHotKey;

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "PROC_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   							IMAGE_ICON, 16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

   hwndMainWindow = hWnd;

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{

	switch (Message)
	{
		case WM_CREATE:

      	// ""   
      	SendMessage(hWnd, WM_SETHOTKEY,
         	(WPARAM)MAKEWORD('I', HOTKEYF_ALT | HOTKEYF_CONTROL), 0);

      	return TRUE;

      case WM_SYSCOMMAND:

      	switch(wParam){
         	case SC_HOTKEY:
            	//       
            	SendMessage(hWnd, WM_COMMAND,
            		(WPARAM)MAKELONG(IDM_HELPABOUT, 0), 0L);
            	break;
            default: DefWindowProc(hWnd, Message, wParam, lParam);
         }
         return TRUE;

      case WM_COMMAND:
         switch(LOWORD(wParam)){

            case IDM_DIALOG:
            	DialogBox(hInst, "HotKeyDialog",
               				0, (DLGPROC)HotKeyDlgProc);
               break;

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_hotkey);
					break;

				case IDM_EXIT:
					PostQuitMessage(0);
					break;
         }
      	return TRUE;

      case WM_DESTROY:

         PostQuitMessage(0);
			return TRUE;
	}
   //      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}

#pragma argsused
BOOL APIENTRY HotKeyDlgProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

	switch(Message){
   	case WM_INITDIALOG:
      	//   Hot-Key
      	hwndHotKey = CreateWindowEx(0, HOTKEY_CLASS, "",
         			  WS_VISIBLE | WS_CHILD,
                    16, 30, 180, 32, hDlg, NULL, hInst, NULL);

         if (!hwndHotKey)
         	return FALSE;

         //   
         wHotKey = (WORD)SendMessage(hwndMainWindow, WM_GETHOTKEY, 0, 0);

         //     Hot-Key
         if(wHotKey != 0)
         	SendMessage(hwndHotKey, HKM_SETHOTKEY, wHotKey, 0);

         //  
         SetFocus(hwndHotKey);

      	break;

      case WM_COMMAND:

      	switch(LOWORD(wParam)){
           	case IDOK:
            	EndDialog(hDlg, TRUE);
               break;

            case IDC_SETHOTKEYBUTTON:
            	//  ""  
            	wHotKey = (WORD)SendMessage(hwndHotKey, HKM_GETHOTKEY, 0, 0);
            	SendMessage(hwndMainWindow, WM_SETHOTKEY, wHotKey, 0);
               break;
         }
      	break;
   }
   return FALSE;
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Hot-Key");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}


