/*
imagelist.cpp
      Image List

 :
  Image list       
 .        
   .    
   .
      , 
 "drag-and-drop"
*/

#include <windows.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "  Image list      "
				  "   .        "
              "    .   "
              "     . "
              "      ,  "
				  " \"drag-and-drop\".";

LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

//  
char const szClassName[] = "ImageListControl";
// 
char const szWindowTitle[] = "  :  ";

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(hInstance, "#801"); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "MIN_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON, 16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	static HIMAGELIST hImageList;
	static HDC hDC, hPaintDC;
   PAINTSTRUCT ps;
   static RECT rImageRect = {0, 0, CX_BMP, CY_BMP};
   static POINT Point;
   static BOOL bCapture = FALSE;
   static int nXBorder, nYBorder, i, dxHotSpot, dyHotSpot;
   COLORREF crMask = 0x00FFFFFF;
   static HPEN hOldPen;

	switch (Message)
	{
		case WM_CREATE:
      	hDC = GetDC(hWnd);

			//  :
      	hImageList = ImageList_Create(CX_BMP, CY_BMP, ILC_MASK, 7, 1);

         //  :
         for (i=IDB_BITMAP1; i<=IDB_BITMAP7; i++)
         	ImageList_AddMasked(hImageList,
            					LoadBitmap(hInst, MAKEINTRESOURCE(i)),
                           (COLORREF) crMask);
         i=0; //  i -    

         nXBorder = GetSystemMetrics(SM_CXSIZEFRAME);
         nYBorder = GetSystemMetrics(SM_CYSIZEFRAME) +
         			  GetSystemMetrics(SM_CYCAPTION) +
                    GetSystemMetrics(SM_CYMENU);

         hOldPen = SelectObject(hDC, (HPEN)WHITE_PEN);
         return 0;

      case WM_PAINT:
      	hPaintDC = BeginPaint(hWnd, &ps);
         // i-     hPaintDC
         ImageList_Draw(hImageList, i, hPaintDC, rImageRect.left,
         					rImageRect.top, ILD_TRANSPARENT);
         EndPaint(hWnd, &ps);
         return 0;

      case WM_RBUTTONDOWN:
         if(i<6) i++; else i=0;
         InvalidateRect(hWnd, &rImageRect, FALSE);
         return 0;

		case WM_LBUTTONDOWN:
			Point.x = LOWORD(lParam);
         Point.y = HIWORD(lParam);
         if(PtInRect(&rImageRect, Point)){
         	SetCapture(hWnd);
            bCapture = TRUE;

            //     
            dxHotSpot = Point.x-rImageRect.left;
            dyHotSpot = Point.y-rImageRect.top;

            FillRect(hDC, &rImageRect, WHITE_BRUSH);

            //    
            //(    "drag-and-drop"
            //  ):
            ImageList_BeginDrag(hImageList, i, dxHotSpot, dyHotSpot);

            //  
            //  :
            ImageList_DragEnter(hWnd, Point.x+nXBorder,
            							Point.y+nYBorder);
         }
         return 0;

      case WM_MOUSEMOVE:
      	if(bCapture)

            //  (  ):
         	ImageList_DragMove(LOWORD(lParam)+nXBorder, HIWORD(lParam)+nYBorder);
         return 0;

      case WM_LBUTTONUP:
      	if(bCapture){

         	//     
         	rImageRect.left = LOWORD(lParam)-dxHotSpot;
            rImageRect.right = rImageRect.left+CX_BMP;
            rImageRect.top = HIWORD(lParam)-dyHotSpot;
            rImageRect.bottom = rImageRect.top+CY_BMP;

         	// :
         	ImageList_EndDrag();

            //  :
            ImageList_DragLeave(hWnd);

            //  :
            ImageList_Draw(hImageList, i, hDC, rImageRect.left,
            					rImageRect.top, ILD_TRANSPARENT);

            ReleaseCapture();

            bCapture = FALSE;
         }
         return 0;

      case WM_COMMAND:
      	switch(wParam){

         	case IDM_EXIT:
            	SendMessage(hWnd, WM_CLOSE, 0, 0);
               break;

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_imagelist);
					break;
         }
      	return 0;

      case WM_DESTROY:

         ReleaseDC(hWnd, hDC);
       	ImageList_Destroy(hImageList);
         SelectObject(hDC, hOldPen);
			PostQuitMessage(0);
			return 0;
	}
   //      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Image List");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

