/*
listview.cpp
      List View

 
       .
        ,
     -     Shell32.dll.
  ,       
.    .    "" 
   .
*/

#include <windows.h>
#include <stdlib.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "       . "
				  "        "
              ",      -  "
              "   Shell32.dll.   , "
              "       .   "
              " \"\"     .";

typedef struct{
	char szIconName[10];
   UINT  iNumber;
}APPLINFO;

LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

int CALLBACK LVCompareProc(LPARAM lParam1, LPARAM lParam2,
LPARAM lParamSort);

APPLINFO rgApplInfo[] = {
	{"",  14},
   {"", 28},
   {"",    29},
   {"",   35},
   {"", 40},
   {"",    41},
   {"",  42},
};

//  
char const szClassName[] = "ListViewControl";
// 
char const szWindowTitle[] = "  :  ";

int iInd = 1;
HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "LVM_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON,	16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	int i;
   RECT rc;
   HIMAGELIST hImlSmall, hImlLarge;
	HICON hIcon;
   LV_COLUMN lvc;
   LV_ITEM lvi;
   static HWND hwndListView;
   DWORD dwStyle;
   LV_DISPINFO * lpLvdi;
   APPLINFO * lpAppinfo;
   static char buf[10];
   NM_LISTVIEW *lpNm;
   int tmp[7] = {14, 28, 29, 35, 40, 41, 42}; //    

	switch (Message)
	{
		case WM_CREATE:
      	GetClientRect(hWnd, &rc);

         //   List view
         hwndListView = CreateWindow(WC_LISTVIEW, // 
         					"",
         					WS_VISIBLE | WS_CHILD | WS_BORDER |
                        LVS_REPORT | LVS_SINGLESEL, //
                        0, 0, rc.right, rc.bottom,
                        hWnd, //  
                        (HMENU)IDC_LISTVIEW, // List view
                        hInst, // 
                        NULL);
         if(hwndListView == NULL) return FALSE;

         //     
         hImlSmall = ImageList_Create(
         			GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON),
                  ILC_MASK, 7, 1);

         //    
         hImlLarge = ImageList_Create(
         			GetSystemMetrics(SM_CXICON), GetSystemMetrics(SM_CYICON),
                  ILC_MASK, 7, 1);

         //    
         for(i=0; i<7; i++){
         	hIcon = (HICON)LoadIcon(hInst, MAKEINTRESOURCE(tmp[i]));
            ImageList_AddIcon(hImlSmall, hIcon);
            ImageList_AddIcon(hImlLarge, hIcon);
         }

         //     List view
         ListView_SetImageList(hwndListView, hImlSmall, LVSIL_SMALL);
         ListView_SetImageList(hwndListView, hImlLarge, LVSIL_NORMAL);

         // 
         memset(&lvc, 0, sizeof(lvc));
         lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
         lvc.fmt = LVCFMT_LEFT;
         lvc.cx = (rc.right-rc.left)/2;

         lvc.iSubItem = 0;
         lvc.pszText = "   Shell32.dll";
         ListView_InsertColumn(hwndListView, 0, &lvc);

         lvc.iSubItem = 1;
         lvc.pszText = "    Shell32.dll";
         ListView_InsertColumn(hwndListView, 1, &lvc);

         //   ()
         memset(&lvi, 0, sizeof(lvi));
         lvi.mask = LVIF_TEXT | LVIF_PARAM | LVIF_IMAGE;
         lvi.pszText = LPSTR_TEXTCALLBACK;

         for (i=0; i<7; i++){
	         lvi.iItem = i;
   	      lvi.iSubItem = 0;
      	   lvi.cchTextMax = 10;
         	lvi.lParam = (LPARAM)&rgApplInfo[i];

            lvi.iImage = i;
            ListView_InsertItem(hwndListView, &lvi);

            lvi.iSubItem = 1;
            ListView_InsertItem(hwndListView, &lvi);
         }
         return 0;

      case WM_COMMAND:
         switch(LOWORD(wParam)){

         	//   :

            // 
         	case IDM_LISTVIEW:
            	dwStyle = GetWindowLong(hwndListView, GWL_STYLE);
               if((dwStyle & LVS_TYPEMASK) != LVS_LIST)
               	SetWindowLong(hwndListView, GWL_STYLE,
                  (dwStyle & ~LVS_TYPEMASK) | LVS_LIST);
               break;

            // 
            case IDM_REPORTVIEW:
               dwStyle = GetWindowLong(hwndListView, GWL_STYLE);
            	if((dwStyle & LVS_TYPEMASK) != LVS_REPORT)
               	SetWindowLong(hwndListView, GWL_STYLE,
                  (dwStyle & ~LVS_TYPEMASK) | LVS_REPORT);
               break;

            // 
            case IDM_SMALLICONVIEW:
               dwStyle = GetWindowLong(hwndListView, GWL_STYLE);
               if((dwStyle & LVS_TYPEMASK) != LVS_SMALLICON)
               	SetWindowLong(hwndListView, GWL_STYLE,
                  (dwStyle & ~LVS_TYPEMASK) | LVS_SMALLICON);
            	break;

            // 
            case IDM_ICONVIEW:
               dwStyle = GetWindowLong(hwndListView, GWL_STYLE);
               if((dwStyle & LVS_TYPEMASK) != LVS_ICON)
               	SetWindowLong(hwndListView, GWL_STYLE,
                  (dwStyle & ~LVS_TYPEMASK) | LVS_ICON);
            	break;

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_listview);
					break;

				case IDM_EXIT:
					PostQuitMessage(0);
					break;
         }
      	return 0;

      case WM_NOTIFY:
      	//       
         //,     lParam, 
         //    
         lpLvdi = (LV_DISPINFO *)lParam;
         lpAppinfo = (APPLINFO *)(lpLvdi->item.lParam);
         lpNm = (NM_LISTVIEW *)lParam;

         //,      List view 
         // IDC_LISTVIEW
         if(((NMHDR *)lParam)->idFrom != IDC_LISTVIEW) return 0L;

         switch(((NMHDR *)lParam)->code){

         	// ,    
            //(    pszText  lvi  
            // LPSTR_TEXTCALLBACK,    
            //   )
         	case LVN_GETDISPINFO:
            	if(lpLvdi->item.mask & LVIF_TEXT){
               	switch(lpLvdi->item.iSubItem){
                  	case 0:
                     	lpLvdi->item.pszText = lpAppinfo->szIconName;
                        break;

                     case 1:
                     	itoa(lpAppinfo->iNumber, buf, 10);
                     	lpLvdi->item.pszText = buf;
                        break;

                     default:
                     	break;
                  }
               }
               break;

            //        
            //
            case LVN_COLUMNCLICK:
            	iInd *= -1;

               //      
               //
            	ListView_SortItems(lpNm->hdr.hwndFrom, LVCompareProc,
               						(LPARAM)(lpNm->iSubItem));
               break;
			}
      	return 0;

      case WM_SIZE:

      	//   
      	MoveWindow(hwndListView, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
         ListView_SetColumnWidth(hwndListView, 0, LOWORD(lParam)/2);
			return 0;

      case WM_DESTROY:

         DestroyWindow(hwndListView);
			PostQuitMessage(0);
			return 0;
	}
   //      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}


// 
int CALLBACK LVCompareProc(LPARAM lParam1, LPARAM lParam2,
LPARAM lParamSort){
	APPLINFO *pAppInfo1 = (APPLINFO *)lParam1;
   APPLINFO *pAppInfo2 = (APPLINFO *)lParam2;
   LPSTR lpStr1, lpStr2;
   int iResult;

   if(pAppInfo1 && pAppInfo2){
   	switch(lParamSort){

      	case 0:
         	lpStr1 = pAppInfo1->szIconName;
            lpStr2 = pAppInfo2->szIconName;
            iResult = strcmpi(lpStr1, lpStr2);
            break;

         case 1:
         	iResult = pAppInfo1->iNumber - pAppInfo2->iNumber;
            break;

         default:
         	iResult = 0;
            break;
      }
   }
   return (iResult*iInd);
};

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "List View");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

