/*
progressbar.cpp
      Progress Bar

 :
   ""    ,  
 Progress Bar.
  - "PBM_STEPID", "PBM_DELTAPOS"  "PBM_SETPOS"
  ,  .
 "Start"  ,   ,  
Progress Bar  , "Stop"  .
        
"PBM_STEPID"  "PBM_DELTAPOS"
*/

#include <windows.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "   \"\"    ,  "
			 "  Progress Bar.   - "
          "\"PBM_STEPID\", \"PBM_DELTAPOS\"  \"PBM_SETPOS\"  "
          " ,  .  \"Start\" "
          " ,   ,   "
          "Progress Bar  , \"Stop\"  .";

BOOL CALLBACK ProgressbarDialogProc(HWND, UINT, WPARAM, LPARAM);

LRESULT CALLBACK WndProc
	  (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam);

//  
char const szClassName[] = "ProgressbarControl";
// 
char const szWindowTitle[] = "  : ";

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "PROC_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON,	16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

	/*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	switch (Message)
	{
		case WM_COMMAND:
      	switch(wParam){

         	case IDM_EXIT:
            	SendMessage(hWnd, WM_CLOSE, 0, 0);
               break;

            case IDM_DIALOG:
            	DialogBox((HINSTANCE)hInst, "ProgressbarDialog", hWnd,
               			 (DLGPROC)ProgressbarDialogProc);
               break;

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_progressbar);
					break;
         }
      	return 0;

		case WM_DESTROY:
			PostQuitMessage(0);
			return 0;

		default :
		//      :
			return DefWindowProc(hWnd, Message, wParam, lParam);
	}
}

#pragma argsused
BOOL CALLBACK ProgressbarDialogProc(HWND hDlg, UINT Message,
										WPARAM wParam, LPARAM lParam){

 static HWND hwndProgressBar; // Progressbar
 static int iPos, nDelta, nStep;
 WORD wMin, wMax;
 BOOL bl;

 switch(Message){

	case WM_INITDIALOG:
		// Progressbar:
      hwndProgressBar = CreateWindow(
      	PROGRESS_CLASS, //  
      	"",
      	WS_CHILD|WS_VISIBLE, // 
         5, 75, 290, 20,
         hDlg, //  
         NULL,
         hInst, // 
         NULL);

      wMin = 0;
      wMax = 20;
      //      Progressbar
      //(wParam = 0;
      //lParam = MAKELONG(wMinRange, wMaxRange))
      SendMessage(hwndProgressBar, PBM_SETRANGE, TRUE, MAKELONG(wMin, wMax));

      // ,      Progressbar
      //(wParam - ;
      //lParam = 0)
      SendMessage(hwndProgressBar, PBM_SETSTEP, 1, 0);

      // Progressbar   
      //(wParam - ,   /  Progressbar;
      //lParam =0)
      SendMessage(hwndProgressBar, PBM_SETPOS, 0, 0);

  		SendDlgItemMessage(hDlg, IDC_PBM_STEPIT, BM_SETCHECK, TRUE, 0);

      SetDlgItemInt(hDlg, IDC_MIN, wMin, FALSE);
      SetDlgItemInt(hDlg, IDC_MAX, wMax, FALSE);

      SetDlgItemInt(hDlg, IDC_DELTA, 1, FALSE);
      SetDlgItemInt(hDlg, IDC_STEP, 1, FALSE);

      return TRUE;

   case WM_TIMER:
   	SetDlgItemInt(hDlg, IDC_POS, iPos, FALSE);
   	/*
       PBM_STEPIT  Progressbar,   
       ,      
      (wParam = lParam = 0)
       PBM_DELTAPOS ,      
       
      (wParam - , lParam = 0)
       PBM_SETPOS  Progressbar   
      (wParam - ,   /  Progressbar, lParam =0)
      */

   	(IsDlgButtonChecked(hDlg, IDC_PBM_STEPIT))
      	? SendMessage(hwndProgressBar, PBM_STEPIT, 0, 0)
   		: (IsDlgButtonChecked(hDlg, IDC_PBM_SETPOS))
         	? SendMessage(hwndProgressBar, PBM_SETPOS, iPos++, 0)
            : SendMessage(hwndProgressBar, PBM_DELTAPOS, nDelta, 0);

   	return 0;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	KillTimer(hDlg, ID_TIMER);
         	EndDialog(hDlg, 0);
            return TRUE;

         case IDC_START:
         	iPos=0;
            nDelta = GetDlgItemInt(hDlg, IDC_DELTA, &bl, FALSE);
            nStep = GetDlgItemInt(hDlg, IDC_STEP, &bl, FALSE);
            SendMessage(hwndProgressBar, PBM_SETSTEP, nStep, 0);
            SetTimer(hDlg, ID_TIMER, 1000, NULL);
	         break;

         case IDC_STOP:
         	KillTimer(hDlg, ID_TIMER);
            break;
      }
      break;
 }
 return FALSE;
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Progress Bar");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

