/*
propertysheet.cpp
      Property Sheet

 :
    .       
,     .
*/

#include <windows.h>
#include <stdlib.h>
#include <commctrl.h>
#include <string.h>

#include "proc.h"   //    
						  //

char *lpBuf = "    .   Property Sheet "
				  "Control    ,     "
              ".";

//,    
typedef struct{
	int nBold;
   int nItalic;
   int nUnderline;
   int nLanguage;
   COLORREF nColor;
} OPTIONS;

OPTIONS opt;

//    Property Sheet
PROPSHEETPAGE psheetPage[3];

// Property Sheet
PROPSHEETHEADER psheetHeader;

//  Property Sheet
HPROPSHEETPAGE hPage[3];

BOOL APIENTRY PSDlgProc1(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam);
BOOL APIENTRY PSDlgProc2(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam);
BOOL APIENTRY PSDlgProc3(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam);


LRESULT CALLBACK WndProc
	  (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam);

HWND hwndMainWindow;

//  
char const szClassName[] = "PropertySheetControl";
// 
char const szWindowTitle[] = "  :  ";

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "PROC_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON,	16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

   hwndMainWindow = hWnd;

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
   HDC hDC;
   RECT rc;
   HFONT hFont, hOldFont;
   PAINTSTRUCT PaintStruct;
   static char* text[] = {" :  ",
                          "Property Sheet Demo"};
   int fnWeight;

	switch (Message)
	{
		case WM_CREATE:
      	//  
         opt.nBold = opt.nItalic = opt.nUnderline = opt.nLanguage = 0;
         opt.nColor = (COLORREF)0x008000;
      	return 0;

      case WM_PAINT   :

		   hDC = BeginPaint(hWnd,&PaintStruct);
         // 
         fnWeight = (opt.nBold == 1)? FW_BOLD : FW_NORMAL;
      	hFont  = CreateFont(30, 0, 0, 0,
           			fnWeight, opt.nItalic, opt.nUnderline,
                  0,	ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                  DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE,
                  "Times New Roman Cyr");
		   hOldFont = SelectObject (hDC, hFont);
		   SetTextColor(hDC, opt.nColor);
         GetClientRect(hWnd, &rc);
         SetTextAlign(hDC, TA_CENTER);
		   TextOut(hDC, rc.right/2, rc.bottom/3, text[opt.nLanguage],
           		  strlen(text[opt.nLanguage]));
		   SelectObject(hWnd, hOldFont);
      	DeleteObject(hFont);
		  	EndPaint(hWnd, &PaintStruct);
		   return 0;

      case WM_COMMAND:
         switch(LOWORD(wParam)){

            case IDM_DIALOG:
            	//  Property Sheet:
               psheetPage[0].dwSize = sizeof(PROPSHEETPAGE);
               psheetPage[0].hInstance = hInst;
               psheetPage[0].pszIcon = NULL;
               psheetPage[0].dwFlags = PSP_USETITLE;
               psheetPage[0].pszTemplate = "PropSheetDialog1";
               psheetPage[0].pfnDlgProc = (DLGPROC)PSDlgProc1;
               psheetPage[0].pszTitle = "Set Effects";
               psheetPage[0].lParam = 0;
               //   Property Sheet   
               //   hPage
               hPage[0] = CreatePropertySheetPage(&psheetPage[0]);

               psheetPage[1].dwSize = sizeof(PROPSHEETPAGE);
               psheetPage[1].hInstance = hInst;
               psheetPage[1].pszIcon = NULL;
               psheetPage[1].dwFlags = PSP_USETITLE;
               psheetPage[1].pszTemplate = "PropSheetDialog2";
               psheetPage[1].pfnDlgProc = (DLGPROC)PSDlgProc2;
               psheetPage[1].pszTitle = "Set Language";
               psheetPage[1].lParam = 0;
               //   Property Sheet   
               //   hPage
               hPage[1] = CreatePropertySheetPage(&psheetPage[1]);

					psheetPage[2].dwSize = sizeof(PROPSHEETPAGE);
               psheetPage[2].hInstance = hInst;
               psheetPage[2].pszIcon = NULL;
               psheetPage[2].dwFlags = PSP_USETITLE;
               psheetPage[2].pszTemplate = "PropSheetDialog3";
               psheetPage[2].pfnDlgProc = (DLGPROC)PSDlgProc3;
               psheetPage[2].pszTitle = "Set Color";
               psheetPage[2].lParam = 0;
               //   Property Sheet   
               //   hPage
               hPage[2] = CreatePropertySheetPage(&psheetPage[2]);

               //  Property Sheet
               psheetHeader.dwSize = sizeof(PROPSHEETHEADER);
               psheetHeader.hInstance = hInst;
               psheetHeader.pszIcon = MAKEINTRESOURCE(BOOK);
               psheetHeader.dwFlags = PSH_USEICONID;
               psheetHeader.hwndParent = hWnd;
               psheetHeader.pszCaption = "Property Sheet for text";
               psheetHeader.nPages = sizeof(psheetPage)/sizeof(PROPSHEETPAGE);
               psheetHeader.phpage = (HPROPSHEETPAGE FAR *)&hPage[0];

               //   Property Sheet
               PropertySheet(&psheetHeader);
               break;

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_propertysheet);
					break;

				case IDM_EXIT:
					PostQuitMessage(0);
					break;
         }
      	return TRUE;

      case WM_DESTROY:

         PostQuitMessage(0);
			return TRUE;
	}
   //      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}


// PSDlgProc1    Property Sheet
#pragma argsused
BOOL APIENTRY PSDlgProc1(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

	switch(Message){
   	case WM_INITDIALOG:
      	SendMessage(GetDlgItem(hDlg, IDC_BOLD), BM_SETCHECK, opt.nBold, 0L);
         SendMessage(GetDlgItem(hDlg, IDC_ITALIC),
         											BM_SETCHECK, opt.nItalic, 0L);
         SendMessage(GetDlgItem(hDlg, IDC_UNDERLINE),
         											BM_SETCHECK, opt.nUnderline, 0L);

      	break;

      case WM_COMMAND:

      	//  Apply
         PropSheet_Changed(GetParent(hDlg), hDlg);
      	break;

      case WM_NOTIFY:
      	switch(((NMHDR *)lParam)->code){
         	case PSN_APPLY:
            	opt.nBold = (int)SendMessage(GetDlgItem(hDlg, IDC_BOLD),
               						BM_GETCHECK, 0L, 0L);
               opt.nItalic = (int)SendMessage(GetDlgItem(hDlg, IDC_ITALIC),
               						BM_GETCHECK, 0L, 0L);
               opt.nUnderline = (int)SendMessage(GetDlgItem(hDlg, IDC_UNDERLINE),
               						BM_GETCHECK, 0L, 0L);
            	InvalidateRect(hwndMainWindow, NULL, TRUE);
            break;
         }
      	break;
   }
   return FALSE;
}

// PSDlgProc2    Property Sheet
#pragma argsused
BOOL APIENTRY PSDlgProc2(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

	switch(Message){
   	case WM_INITDIALOG:
      	SendMessage(GetDlgItem(hDlg, IDC_ENGLISH), BM_SETCHECK,
         				opt.nLanguage, 0L);
         SendMessage(GetDlgItem(hDlg, IDC_RUSSIAN), BM_SETCHECK,
         				(opt.nLanguage)?0:1, 0L);

      	break;

      case WM_COMMAND:

      	//  Apply
         PropSheet_Changed(GetParent(hDlg), hDlg);
      	break;

      case WM_NOTIFY:
      	switch(((NMHDR *)lParam)->code){
         	case PSN_APPLY:
            	opt.nLanguage = (int)SendMessage(GetDlgItem(hDlg, IDC_ENGLISH),
               						BM_GETCHECK, 0L, 0L);
               InvalidateRect(hwndMainWindow, NULL, TRUE);
				break;
         }
      	break;
   }
   return FALSE;
}

// PSDlgProc3    Property Sheet
#pragma argsused
BOOL APIENTRY PSDlgProc3(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){
   BYTE r, g, b;
   BOOL bl;

	switch(Message){
   	case WM_INITDIALOG:

			SetDlgItemInt(hDlg, IDC_RED, GetRValue(opt.nColor), FALSE);
         SetDlgItemInt(hDlg, IDC_GREEN, GetGValue(opt.nColor), FALSE);
         SetDlgItemInt(hDlg, IDC_BLUE, GetBValue(opt.nColor), FALSE);
      	break;

      case WM_COMMAND:

      	//  Apply
         PropSheet_Changed(GetParent(hDlg), hDlg);
      	break;

      case WM_NOTIFY:
      	switch(((NMHDR *)lParam)->code){
         	case PSN_APPLY:

               #pragma warn -sig
					r = (BYTE)GetDlgItemInt(hDlg, IDC_RED, &bl, FALSE);
               //#pragma warn -sig
               g = (BYTE)GetDlgItemInt(hDlg, IDC_GREEN, &bl, FALSE);
               //#pragma warn -sig
               b = (BYTE)GetDlgItemInt(hDlg, IDC_BLUE, &bl, FALSE);
               opt.nColor = RGB(r, g, b);
               InvalidateRect(hwndMainWindow, NULL, TRUE);
				break;
         }
      	break;
   }
   return FALSE;
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Property Sheet");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

