/*
richedit.cpp
      Ridh Edit

 :
    ,    
 RTF.
  :
-    ;
-  , ,    ;
-  .
*/

#include <windows.h>
//#include <commdlg.h>
#include <richedit.h>

#include "proc.h"   //    
						  //

char *lpBuf = "    ,  "
				  "     RTF.   : "
              "   ;  , ,   "
              " ;  .";

HINSTANCE   hRTFLib;

LRESULT CALLBACK WndProc
	  (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam);

//  
char const szClassName[] = "RichEditControl";
// 
char const szWindowTitle[] =
				  	"  :    RTF-";

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	//       Rich Edit
   hRTFLib = LoadLibrary("RICHED32.DLL");
   if (!hRTFLib){
		MessageBox(NULL, "LoadLibrary Failed", "Error", MB_OK);
	   return 0;
   }

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "REM_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON, 16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

	/*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
   static HWND hwndRichEdit; //   Rich Edit
   CHARRANGE charr;
   CHARFORMAT cf;
   CHOOSEFONT ChooseFontStruct;
   LOGFONT lf;
   HDC hDC;
   PARAFORMAT pf;
   RECT rc;

	switch (Message)
	{
		case WM_CREATE:
      	GetClientRect(hWnd, &rc);

         //  Rich Edit
			hwndRichEdit = CreateWindowEx(0L,
         					"RICHEDIT",   //  
	                		"",
                        WS_CHILD | WS_VISIBLE | WS_BORDER | WS_HSCROLL |
                        WS_VSCROLL | ES_NOHIDESEL | ES_AUTOVSCROLL |
                        ES_SAVESEL | ES_SUNKEN | ES_MULTILINE,    // 
                   		0, rc.right,
 		                  0, rc.bottom,
								hWnd,                //   
								(HMENU)ID_RICHEDIT,  //   Rich Edit
								hInst,               //  
								NULL);
         if(hwndRichEdit == NULL) return FALSE;

         //     Rich Edit
			SetFocus(hwndRichEdit);
         return 0;

      case WM_SETFOCUS:
      	//     ,
         //   
      	SetFocus(hwndRichEdit);
         return 0;

      case WM_SIZE:
      	//   Rich Edit   
         //     :
      	if (hwndRichEdit)
				MoveWindow(hwndRichEdit, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
			return 0;

      case WM_COMMAND:
         switch(LOWORD(wParam)){

         	//  
            case IDM_FORMAT_BOLD:
					cf.cbSize = sizeof(cf);

					//  
					SendMessage(hwndRichEdit, EM_GETCHARFORMAT, TRUE, (LPARAM)&cf);

					//   dwEffects,    
               //   bold
					cf.dwMask = CFM_BOLD;

					// ,   
					cf.dwEffects ^= CFE_BOLD;

					//  
					SendMessage(hwndRichEdit, EM_SETCHARFORMAT,
               				SCF_SELECTION, (LPARAM)&cf);
					break;

            //  
				case IDM_FORMAT_ITALIC:

            	//  cf
               cf.cbSize = sizeof(cf);

               //  
               SendMessage(hwndRichEdit, EM_GETCHARFORMAT, TRUE, (LPARAM)&cf);

               //   dwEffects,    
               //   italic
               cf.dwMask = CFM_ITALIC;

               // ,   
               cf.dwEffects ^= CFE_ITALIC;

               //  
               SendMessage(hwndRichEdit, EM_SETCHARFORMAT,
               				SCF_SELECTION, (LPARAM)&cf);
               break;

            //   
            case IDM_FORMAT_UNDERLINE:

               cf.cbSize = sizeof(cf);

					//  
               SendMessage(hwndRichEdit, EM_GETCHARFORMAT, TRUE, (LPARAM)&cf);

					//   dwEffects,    
               //   italic
               cf.dwMask = CFM_UNDERLINE;

               // ,    
               //
               cf.dwEffects ^= CFE_UNDERLINE;

               //  
               SendMessage(hwndRichEdit, EM_SETCHARFORMAT,
               				SCF_SELECTION, (LPARAM)&cf);
               break;

            //  
            case IDM_FORMAT_FONT:

					cf.cbSize = sizeof(cf);

               //   
               SendMessage(hwndRichEdit, EM_GETCHARFORMAT, TRUE, (LPARAM)&cf);

               // 0-  ,  
               //   
               memset(&ChooseFontStruct, 0, sizeof(CHOOSEFONT));
               memset(&lf, 0, sizeof(LOGFONT));

               hDC = GetDC(hWnd);

               //   twips-  
               //Each point is 20 twips.
               lf.lfHeight = cf.yHeight/-20;

               //      ,  
               //   
               if (cf.dwEffects & CFE_BOLD) lf.lfWeight = FW_BOLD;
					else lf.lfWeight = FW_NORMAL;

               //    ,  
               // ,    
               //:
               #pragma warn -sig
               lf.lfItalic = (BOOL)(cf.dwEffects & CFE_ITALIC);
               lf.lfUnderline = (BOOL)(cf.dwEffects & CFE_UNDERLINE);
               lf.lfStrikeOut = (BOOL)(cf.dwEffects & CFE_STRIKEOUT);

               // ,   
               #pragma warn .sig
               lf.lfCharSet = DEFAULT_CHARSET;

               // ,   
               lf.lfQuality = DEFAULT_QUALITY;

               //  
               lf.lfPitchAndFamily = cf.bPitchAndFamily;

               //  
               lstrcpy(lf.lfFaceName, cf.szFaceName);

               //    
					ChooseFontStruct.lStructSize = sizeof(ChooseFontStruct);
               ChooseFontStruct.hwndOwner = hWnd;
               ChooseFontStruct.hDC = hDC;
               ChooseFontStruct.lpLogFont = &lf;
               ChooseFontStruct.Flags = CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT
               								 | CF_EFFECTS | CF_FORCEFONTEXIST;
               ChooseFontStruct.rgbColors = cf.crTextColor;
               ChooseFontStruct.nFontType = SCREEN_FONTTYPE;

               //       
					if (ChooseFont(&ChooseFontStruct)){

						//    dwEffects
                  cf.dwMask = CFM_BOLD | CFM_FACE | CFM_ITALIC |
                  				CFM_OFFSET | CFM_SIZE | CFM_UNDERLINE |
                              CFM_STRIKEOUT | CFM_COLOR;

               	//   twips-
	               cf.yHeight = lf.lfHeight * -20;

   	            //  dwEffects
      	         cf.dwEffects = 0;
         	      if (FW_BOLD == lf.lfWeight)
            	   	cf.dwEffects |= CFE_BOLD;
               	if (lf.lfItalic)
	               	cf.dwEffects |= CFE_ITALIC;
   	            if (lf.lfUnderline)
      	         	cf.dwEffects |= CFE_UNDERLINE;
                  if (lf.lfStrikeOut)
      	         	cf.dwEffects |= CFE_STRIKEOUT;

                  //
                  cf.crTextColor = ChooseFontStruct.rgbColors;

                  // :
                  cf.bCharSet = lf.lfCharSet;

                  //  
            	   cf.bPitchAndFamily = lf.lfPitchAndFamily;

                  //   
               	lstrcpy(cf.szFaceName, lf.lfFaceName);

	               //    
						SendMessage(hwndRichEdit, EM_SETCHARFORMAT, SCF_SELECTION,
                  				(LPARAM)&cf);
    				}

               ReleaseDC(hWnd, hDC);
               break;

            //       
            case IDM_FORMAT_LEFT:
            	pf.cbSize = sizeof(pf);
               pf.dwMask = PFM_ALIGNMENT;
               pf.wAlignment = PFA_LEFT;

               //    
               SendMessage(hwndRichEdit, EM_SETPARAFORMAT, 0, (LPARAM)&pf);
               break;

            //       
            case IDM_FORMAT_RIGHT:
               pf.cbSize = sizeof(pf);
               pf.dwMask = PFM_ALIGNMENT;
               pf.wAlignment = PFA_RIGHT;

               //    
               SendMessage(hwndRichEdit, EM_SETPARAFORMAT, 0, (LPARAM)&pf);
            	break;

            //      
            case IDM_FORMAT_CENTER:
               pf.cbSize = sizeof(pf);
               pf.dwMask = PFM_ALIGNMENT;
               pf.wAlignment = PFA_CENTER;

               //    
               SendMessage(hwndRichEdit, EM_SETPARAFORMAT, 0, (LPARAM)&pf);
            	break;

            //    ""

            case IDM_EDIT_UNDO:
            	SendMessage(hwndRichEdit, EM_UNDO, 0, 0L);
               break;

            case IDM_EDIT_CUT:
            	SendMessage(hwndRichEdit, WM_CUT, 0, 0L);
               break;

            case IDM_EDIT_COPY:
            	SendMessage(hwndRichEdit, WM_COPY, 0, 0L);
               break;

            case IDM_EDIT_PASTE:
            	SendMessage(hwndRichEdit, WM_PASTE, 0, 0L);
               break;

            case IDM_EDIT_DELETE:
            	SendMessage(hwndRichEdit, WM_CLEAR, 0, 0L);
               break;

            //  
            case IDM_EDIT_SELECTALL:
            	// ...
            	charr.cpMin = 0;
               //...  
               charr.cpMax = -1;

            	SendMessage(hwndRichEdit, EM_EXSETSEL, 0, (LPARAM)&charr);
               break;

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_richedit);
					break;

				case IDM_EXIT:
					PostQuitMessage(0);
					break;
         }
      	return TRUE;

      case WM_DESTROY:

      	//  
      	if (hwndRichEdit)
				DestroyWindow(hwndRichEdit);

         // 
         if (hRTFLib)
				FreeLibrary(hRTFLib);
            
         PostQuitMessage(0);
			return TRUE;
	}
   //      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Rich Edit");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

