/*
spin.cpp
      Up Down ()

 :
   ""    ,    
   .
        
"Spin Demo"   .
*/

#include <windows.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "   \"\"    ,  "
				  "      . "
              "       "
              "  \"Spin Demo\"   .";

BOOL CALLBACK SpinDialogProc(HWND, UINT, WPARAM, LPARAM);

LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

//  
char const szClassName[] = "Spin";
// 
char const szWindowTitle[] = "  : ";

HINSTANCE hInst;

int nStr = 0;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "PROC_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON,	16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

	/*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	HDC hDC;
   PAINTSTRUCT ps;
   LPCTSTR lpString = "Spin Demo";
   int i;

	switch (Message)
	{
      case WM_PAINT:
      	hDC = BeginPaint(hWnd, &ps);
         for (i=0; i<nStr; i++)
         	TextOut(hDC, 1, 20*i, lpString, strlen(lpString));
         EndPaint(hWnd, &ps);
         return 0;

      case WM_COMMAND:
      	switch(wParam){
         	case IDM_EXIT:
            	SendMessage(hWnd, WM_CLOSE, 0, 0);
               break;
            case IDM_DIALOG:
            	DialogBox((HINSTANCE)hInst, "SpinDialog", hWnd,
               			 (DLGPROC)SpinDialogProc);
               InvalidateRect(hWnd, NULL, TRUE);
               break;
            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_spin);
					break;
         }
      	return 0;

		case WM_DESTROY:
			PostQuitMessage(0);
			return 0;
	}
	//      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}

#pragma argsused
BOOL CALLBACK SpinDialogProc(HWND hDlg, UINT Message,
									  WPARAM wParam, LPARAM lParam){

 static HWND hwndEdit, hwndSpin;

 switch(Message){
	case WM_INITDIALOG:
   	//    -    
   	hwndEdit = GetDlgItem(hDlg, IDE_EDIT);

      //   Up Down ()
		hwndSpin = CreateUpDownControl(WS_CHILD | WS_BORDER | WS_VISIBLE |
         						  UDS_SETBUDDYINT | UDS_ALIGNRIGHT |
                             UDS_WRAP,		//
                             2, 12, 50, 50,//   
                             hDlg,			//  
                             ID_SPIN,		// 
                             hInst,			// 
                             hwndEdit,		//  
                             10,				//  
                             0,				//  
                             nStr);			// 
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	//  
         	nStr = LOWORD(SendMessage(hwndSpin, UDM_GETPOS, 0, 0));
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Up-Down");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

