/*
statusbar.cpp
      Status Window

 :
     ,    
 :
1 -   ;
2 -  ;
3 -     ;
4 -       .
 2  3  .
 1  4       .
*/

#include <windows.h>
#include <stdlib.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "     ,   "
				  "   : 1 -   ; "
              "2 -  ; 3 -    "
              " ; 4 -       "
              ".  2  3  .  1  4  "
              "     .";

LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

//  
char const szClassName[] = "StatusbarControl";
// 
char const szWindowTitle[] = "  :  ";

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
	HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "MIN_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON,	16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

	/*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	static HWND hwndSb; //  
	static HBITMAP hSbLogoBmp; //   
	int xClientView, yClientView;
   int ptWidth[4];
   LPDRAWITEMSTRUCT lpDis;
   HDC hdcMem;
   HBITMAP hbmOld;
   BITMAP bm;
   char buf1[10], buf2[10];

	switch (Message)
	{
		case WM_CREATE:
			//  :
        	hwndSb = CreateStatusWindow(
         	WS_CHILD | WS_BORDER | WS_VISIBLE | SBARS_SIZEGRIP,// 
            (LPCSTR)"",       //     
            hWnd,             //  
            (UINT)IDS_STATUSBAR); //   

         //    4 :
         SendMessage(hwndSb, SB_SETPARTS, 4, (LPARAM)ptWidth);

         //   :
         SendMessage(hwndSb, SB_SETTEXT, 0, (LPARAM)" ");

         //  4 :
         //(       :
         //\t -    
         //\t\t -      )
			SendMessage(hwndSb, SB_SETTEXT, 3, (LPARAM)"\t\t\"\"->    ");

         //bitmap  2 :
         hSbLogoBmp = LoadBitmap(hInst, MAKEINTRESOURCE(IDB_SBLOGO));
         if (!hSbLogoBmp) return 0;

         //  2   :
         SendMessage(hwndSb, SB_SETTEXT, 1 | SBT_OWNERDRAW,
         	(LPARAM)hSbLogoBmp);
         return 0;

		case WM_SIZE:
			xClientView = LOWORD(lParam);
         yClientView = HIWORD(lParam);

         //   :
         SendMessage(hwndSb, WM_SIZE, xClientView, yClientView);

         //    :
         ptWidth[0] = xClientView/2;
         ptWidth[1] = xClientView/2 + 20;
         ptWidth[2] = xClientView/2 + 20 + 60;
         ptWidth[3] = -1;
         SendMessage(hwndSb, SB_SETPARTS, 4, (LPARAM)ptWidth);
         return 0;

		case WM_MOUSEMOVE:
         itoa((int)LOWORD(lParam), buf1, 10);
         itoa((int)HIWORD(lParam), buf2, 10);
         strcat(buf1, ": ");
         strcat(buf1, buf2);
         //  3   :
         SendMessage(hwndSb, SB_SETTEXT, 2, (LPARAM)buf1);
      	return 0;

         //     3  Statusbar:
		case WM_DRAWITEM:

     		//DRAWITEMSTRUCT - ,    
         // lParam  WM_DRAWITEM
      	lpDis = (LPDRAWITEMSTRUCT)lParam;

        	if (lpDis->CtlID == IDS_STATUSBAR){

         	//    :
            hdcMem = CreateCompatibleDC(lpDis->hDC);

            //   bitmap     :
            hbmOld = SelectObject(hdcMem, hSbLogoBmp);

            //   bitmap':
            GetObject(hSbLogoBmp, sizeof(bm), &bm);

            // bitmap'     :
            BitBlt(lpDis->hDC,
					lpDis->rcItem.left, lpDis->rcItem.top,
            	bm.bmWidth, bm.bmHeight, hdcMem, 0, 0, SRCCOPY);

            // bitmap  :
            SelectObject(hdcMem, hbmOld);

            //  :
            DeleteDC(hdcMem);
         }
         return 0;


		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
         	case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_statusbar);
					break;
				case IDM_EXIT:
            	PostQuitMessage(0);
					break;
         }
			return 0;

		case WM_DESTROY:
			PostQuitMessage(0);
			return 0;

		default :
		//      :
			return DefWindowProc(hWnd, Message, wParam, lParam);
	}
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Status Window");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}


