/*
tabcontrol.cpp
      Tab control

 :
   ,       
 .         
.
*/

#include <windows.h>
#include <stdio.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "   ,     "
				  "    .      "
              "    .";

BOOL CALLBACK DialogProc(HWND hDlg, UINT Message,
										WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

//  
char const szClassName[] = "TabControls";
// 
char const szWindowTitle[] = "  : ";

HINSTANCE hInst;
HWND hwndSb; //  
HBITMAP hSbLogoBmp; //   
BOOL CALLBACK SpinDialogProc(HWND, UINT, WPARAM, LPARAM);
int nStr = 0;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH); //  
	WndClass.lpszMenuName = "MIN_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON,	16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW&~WS_THICKFRAME&
                       ~WS_MAXIMIZEBOX, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X, Y 
							  400, 300, // ,  
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	static HWND hwndTab;
   RECT Rect;
   LPNMHDR lpNMHdr;
   LPTOOLTIPTEXT lpToolTipText;
   static HWND hDlg = 0;
   static int nTab;
   TC_ITEM TC_Item;

	switch (Message)
	{
		case WM_CREATE:
      	GetClientRect(hWnd, &Rect);
         //    Tab control
         hwndTab = CreateWindow(WC_TABCONTROL, //  
         							  "",
                                WS_VISIBLE | WS_TABSTOP | WS_CHILD |
                                TCS_TOOLTIPS,  //
                                0, 0,          //
                                Rect.right, Rect.bottom, //
                                hWnd,          //  
                                NULL,
                                hInst,         // 
                                NULL);

         //  TC_ITEM    
         TC_Item.mask = TCIF_TEXT; //  ,  
         								  //
         TC_Item.iImage = -1;      //   
         TC_Item.pszText = "The first dialog"; // 
         // 
         TabCtrl_InsertItem(hwndTab, 0, &TC_Item);

         TC_Item.pszText = "The second dialog";
         TabCtrl_InsertItem(hwndTab, 1, &TC_Item);

         TC_Item.pszText = "The third dialog";
         TabCtrl_InsertItem(hwndTab, 2, &TC_Item);

         // ,    
         hDlg = CreateDialog(hInst, "TabControlDialog1",
         							hwndTab, (DLGPROC)DialogProc);
         return 0;

		case WM_MOVE:
			if(hDlg)	DestroyWindow(hDlg);

			//  
			switch(nTab){
				case 0:
					hDlg = CreateDialog(hInst, "TabControlDialog1", hwndTab,
                     				  (DLGPROC)DialogProc);
               break;
            case 1:
             	hDlg = CreateDialog(hInst, "TabControlDialog2", hwndTab,
                     				  (DLGPROC)DialogProc);
               break;
            case 2:
              	hDlg = CreateDialog(hInst, "TabControlDialog3", hwndTab,
                     				  (DLGPROC)DialogProc);
               break;
         }
      	return 0;

      case WM_SIZE:
         if(wParam==SIZE_MINIMIZED)
         	if(hDlg)	DestroyWindow(hDlg);
      	break;

      case WM_NOTIFY:
         lpNMHdr = (LPNMHDR)lParam;

         switch (lpNMHdr->code){
            //    
         	case TTN_NEEDTEXT:
            	lpToolTipText = (LPTOOLTIPTEXT)lParam;
            	sprintf(lpToolTipText->lpszText, "Tip about tab No %d",
         					lpToolTipText->hdr.idFrom);
         		break;

            //  
            case TCN_SELCHANGE:
					if(hDlg) DestroyWindow(hDlg);

               //   
               nTab = TabCtrl_GetCurSel((HWND)lpNMHdr->hwndFrom);

               //  
               switch(nTab){
               	case 0:
                  	hDlg = CreateDialog(hInst, "TabControlDialog1", hwndTab,
                     							(DLGPROC)DialogProc);
                     break;
                  case 1:
                  	hDlg = CreateDialog(hInst, "TabControlDialog2", hwndTab,
                     							(DLGPROC)DialogProc);
                     break;
                  case 2:
                  	hDlg = CreateDialog(hInst, "TabControlDialog3", hwndTab,
                     							(DLGPROC)DialogProc);
                     break;
               }
               break;
         }
         return 0;

      case WM_COMMAND:
         switch(LOWORD(wParam)){

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_tab);
					break;

				case IDM_EXIT:
					PostQuitMessage(0);
					break;
         }
      	return TRUE;

      case WM_DESTROY:
         PostQuitMessage(0);
			return 0;
   }
   //      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}

#pragma argsused
BOOL CALLBACK DialogProc(HWND hDlg, UINT Message,
										WPARAM wParam, LPARAM lParam){
 switch(Message){
   case WM_COMMAND:
   	PostQuitMessage(0);
			return TRUE;
 }
 return FALSE;
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Tab");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

