/*
toolbar.cpp
      Toolbar

 :
     ,    
   ,   .
     "" 
*/


#include <windows.h>
#include <stdlib.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "     ,   "
				  "     ,   . "
              "     \"\".";

//,      
typedef struct{
	int iBitmap;
	int idCommand;
   BYTE cr;
   BYTE cg;
   BYTE cb;
} BUTTONINFO;

BUTTONINFO ButtonInfo[] =
{
	{0, ID_COLOR_RED, 255, 0, 0},
   {1, ID_COLOR_BLUE, 0, 0, 128},
	{2, ID_COLOR_GREEN, 0, 128, 0},
	{3, ID_COLOR_YELLOW, 255, 255, 0},
	{4, ID_COLOR_MAROON, 128, 0, 0},
	{0, 0, 0, 0, 0},
	{5, ID_FIGURE_SQUARE,  0, 0, 0},
	{6, ID_FIGURE_CIRCLE,  0, 0, 0}
};

LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

//  
char const szClassName[] = "ToolBarControl";
// 
char const szWindowTitle[] = "  :  ";

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "TBM_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   							IMAGE_ICON, 16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
   static HWND hTBWnd;
   PAINTSTRUCT ps;
   HDC hDC;
   LPTOOLTIPTEXT lpToolTipText;
   CHAR szBuf[20];
   static int f = 0, i;
   static COLORREF c = 0xFFFFFF;
   static RECT rc;
   HBRUSH hOldBrush;
   static TBBUTTON tbButtons[8];

	switch (Message)
	{
		case WM_CREATE:

         //     
         for(i=0; i<8; i++){
	         tbButtons[i].iBitmap = ButtonInfo[i].iBitmap;
   	 		tbButtons[i].idCommand = ButtonInfo[i].idCommand;
    			tbButtons[i].fsState = TBSTATE_ENABLED;
    			tbButtons[i].fsStyle = TBSTYLE_BUTTON;
            // :
	    		tbButtons[i].dwData = RGB(ButtonInfo[i].cr, ButtonInfo[i].cg,
            								  ButtonInfo[i].cb);
   	 		tbButtons[i].iString = 0;
      	}
         tbButtons[5].fsStyle = TBSTYLE_SEP; //  

         //  Toolbar
         hTBWnd = CreateToolbarEx(
         	hWnd,
            WS_CHILD | WS_BORDER | WS_VISIBLE | TBSTYLE_TOOLTIPS,
            IDT_TOOLBAR,
            7,
            hInst,
            IDB_TBBITMAP, //    
            (LPCTBBUTTON)&tbButtons, //     
            8, // 
            16, 16, // 
            16, 16, // 
            sizeof(TBBUTTON)); // 
         if(hTBWnd == NULL) return FALSE;

         GetClientRect(hWnd, &rc);
         rc.left+=rc.right/5;
         rc.top+=rc.bottom/5;
         rc.right-=rc.left;
         rc.bottom*=(4/5);

         return 0;

      case WM_PAINT:
      	hDC = BeginPaint(hWnd, &ps);

         hOldBrush = SelectObject(hDC, CreateSolidBrush(c));
      	(f==0) ? Ellipse(hDC, rc.left, rc.top, rc.right, rc.bottom)
         		 : Rectangle(hDC, rc.left, rc.top, rc.right, rc.bottom);
         SelectObject(hDC, hOldBrush);
         EndPaint(hWnd, &ps);
      	return 0;

      case WM_COMMAND:
         switch(LOWORD(wParam)){

            case ID_COLOR_RED:
            case ID_COLOR_BLUE:
            case ID_COLOR_GREEN:
            case ID_COLOR_YELLOW:
            case ID_COLOR_MAROON:
            	c = (COLORREF)(tbButtons[LOWORD(wParam)-ID_COLOR_RED]).dwData;
               InvalidateRect(hWnd, &rc, TRUE);
               break;
            case ID_FIGURE_SQUARE:
               f = 1;
               InvalidateRect(hWnd, &rc, TRUE);
            	break;

            case ID_FIGURE_CIRCLE:
            	f = 0;
               InvalidateRect(hWnd, &rc, TRUE);
            	break;

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_toolbar);
					break;

				case IDM_EXIT:
					PostQuitMessage(0);
					break;
         }
      	return 0;

      case WM_NOTIFY:

         switch(((NMHDR *)lParam)->code){

            //   ,   
            // 
         	case TTN_NEEDTEXT:
            	lpToolTipText = (LPTOOLTIPTEXT)lParam;
               LoadString(hInst, lpToolTipText->hdr.idFrom,
               			  szBuf, sizeof(szBuf));
               lpToolTipText->lpszText = szBuf;
               break;
         }

      	return 0;

      case WM_SIZE:

         SendMessage(hTBWnd, WM_SIZE, LOWORD(lParam), HIWORD(lParam));

         rc.right=LOWORD(lParam)*4/5;
         rc.bottom=HIWORD(lParam)*4/5;
         rc.left=rc.right/4;
         rc.top=rc.bottom/4;
			return 0;

      case WM_DESTROY:

         PostQuitMessage(0);
			return 0;
	}
   //      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Toolbar");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

