/*
tooltip.cpp
      Tooltip

 :
       ,
    ,   .
 ""   ,   
 (       
hook-).
*/

#include <windows.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "       , "
				  "    ,   "
              ".  \"\"   ,  "
              "   (   "
              "     hook-).";

BOOL CALLBACK TooltipDialogProc(HWND, UINT, WPARAM, LPARAM);
BOOL EnumChildProc(HWND, LPARAM);
LRESULT CALLBACK GetMsgProc(int, WPARAM, LPARAM);

LRESULT CALLBACK WndProc
	  (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam);

//  
char const szClassName[] = "ToolTipsControl";
// 
char const szWindowTitle[] = "  : ";

HINSTANCE hInst;
HHOOK hhk;
HWND hwndTT, hdlg;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
	WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "PROC_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON, 16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	HDC hDC;
   PAINTSTRUCT ps;
   HPEN hOldPen;
   POINT Point;
	static RECT Rect;
   TOOLINFO ToolInfo;
   static HWND hToolTipWnd;
   MSG Msg;
   int id = 0, i, j;     //id - offset to string identifiers
   static char *szTips[] = {"ToolTip #1", "ToolTip #2",
   								 "ToolTip #3", "ToolTip #4"};

	switch (Message)
	{
		case WM_CREATE:
         GetClientRect(hWnd, &Rect);
         //   tooltip
         hToolTipWnd = CreateWindowEx(0L,
         									  TOOLTIPS_CLASS, // 
                                      "",
         									  TTS_ALWAYSTIP,  //
                                      CW_USEDEFAULT, CW_USEDEFAULT,
                                      CW_USEDEFAULT, CW_USEDEFAULT,
                                      hWnd,		//  
                                      NULL,
                                      hInst,    // 
                                      NULL);

         if(!hToolTipWnd)
         	return 0;

   		for (i = 0; i < 2 ; i++ )
      		for (j = 0; j < 2; j++) {
            	//      
         		ToolInfo.cbSize = sizeof(TOOLINFO);
		         ToolInfo.uFlags = 0;
   		      ToolInfo.hwnd = hWnd;
      		   ToolInfo.uId = (UINT)id;      // 
         		ToolInfo.hinst = hInst;
	         	ToolInfo.lpszText = (LPSTR)szTips[id++];  // 
               //  :
	   	      ToolInfo.rect.left = i * Rect.right/2;
   	   	   ToolInfo.rect.top = j * Rect.bottom/2;
      	   	ToolInfo.rect.right = i * ToolInfo.rect.left + Rect.right/2;
	      	   ToolInfo.rect.bottom = j * ToolInfo.rect.top + Rect.bottom/2;

               // 
					SendMessage(hToolTipWnd, TTM_ADDTOOL, 0,
         						(LPARAM)(LPTOOLINFO) &ToolInfo);
         }

      	return 0;

      case WM_PAINT:
      	hDC = BeginPaint(hWnd, &ps);
         hOldPen = SelectObject(hDC, CreatePen(PS_SOLID, 0,
         							  (COLORREF)RGB(0, 0, 128)));
         MoveToEx(hDC, 0, Rect.bottom/2, &Point);
         LineTo(hDC, Rect.right, Rect.bottom/2);
         MoveToEx(hDC, Rect.right/2, 0, &Point);
         LineTo(hDC, Rect.right/2, Rect.bottom);
         SelectObject(hDC, hOldPen);
         EndPaint(hWnd, &ps);
      	return 0;

      case WM_MOUSEMOVE:
      case WM_LBUTTONDOWN:
      case WM_LBUTTONUP:
      case WM_RBUTTONDOWN:
      case WM_RBUTTONUP:
      	//   
      	if(hToolTipWnd){
	         Msg.hwnd = hWnd;
   	      Msg.lParam = lParam;
      	   Msg.wParam = wParam;
         	Msg.message = Message;
	         SendMessage(hToolTipWnd, TTM_RELAYEVENT, 0, (LPARAM)(LPMSG) &Msg);
         }
         return 0;

      case WM_SIZE:
         GetClientRect(hWnd, &Rect);
         id = 0;
         for (i = 0; i < 2 ; i++ )
      		for (j = 0; j < 2; j++) {
            	ToolInfo.cbSize = sizeof(TOOLINFO);
         		ToolInfo.hwnd = hWnd;
      		   ToolInfo.uId = (UINT)id;
               ToolInfo.rect.left = i * Rect.right/2;
   	   	   ToolInfo.rect.top = j * Rect.bottom/2;
      	   	ToolInfo.rect.right = i * ToolInfo.rect.left + Rect.right/2;
	      	   ToolInfo.rect.bottom = j * ToolInfo.rect.top + Rect.bottom/2;
               id++;

               //   
					SendMessage(hToolTipWnd,  TTM_NEWTOOLRECT, 0,
         						(LPARAM)(LPTOOLINFO) &ToolInfo);
				}

			return 0;

      case WM_COMMAND:
         switch(LOWORD(wParam)){

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_tootip);
					break;

            case IDM_DIALOG:
            	CreateDialog(hInst, "TooltipDialog", hWnd,
               				 (DLGPROC)TooltipDialogProc);
            	break;

				case IDM_EXIT:
					PostQuitMessage(0);
					break;
         }
      	return 0;

      case WM_DESTROY:
         PostQuitMessage(0);
			return 0;

		default :
		//      :
			return DefWindowProc(hWnd, Message, wParam, lParam);
	}
}

// 
#pragma argsused
BOOL CALLBACK TooltipDialogProc(HWND hDlg, UINT Message,
										  WPARAM wParam, LPARAM lParam)
{
   LPTOOLTIPTEXT lpttt;
   int idCtrl;

	switch(Message){
		case WM_INITDIALOG:
         hdlg = hDlg;

         //   Tooltip
			hwndTT = CreateWindowEx(0,
         								TOOLTIPS_CLASS, // 
                                 (LPSTR)NULL,
                                 TTS_ALWAYSTIP,  //
                                 CW_USEDEFAULT, CW_USEDEFAULT,
                                 CW_USEDEFAULT, CW_USEDEFAULT,
                                 hDlg,           //  
                                 (HMENU)NULL,
                                 hInst,          // 
                                 NULL);
			if (hwndTT == NULL) return FALSE;

         //      ,
         //   
			if (!EnumChildWindows(hDlg, (WNDENUMPROC) EnumChildProc, 0))
				return FALSE;

			// hook- GetMsgProc  WH_GETMESSAGE,
         //         
         //tooltip control
			hhk = (HHOOK)SetWindowsHookEx(WH_GETMESSAGE, // hook-
     										(HOOKPROC)GetMsgProc,// hook-
     										(HINSTANCE)hInst,// 
                                 GetCurrentThreadId());// 

			if (hhk == (HHOOK) NULL) return FALSE;

         return TRUE;



      case WM_NOTIFY:

         //   
        	if ((((LPNMHDR) lParam)->code) == TTN_NEEDTEXT) {


      		//  ,   
            //
            idCtrl = GetDlgCtrlID((HWND)((LPNMHDR)lParam)->idFrom);
      		lpttt = (LPTOOLTIPTEXT)lParam;
      		switch (idCtrl) {

           		case IDC_TT_CHECKBOX:
              		lpttt->lpszText = "checkbox";
              		break;

           		case IDC_TT_BUTTON:
              		lpttt->lpszText = "button";
              		break;

           		case IDC_TT_BUTTON2:
              		lpttt->lpszText = "  button";
              		break;

               case IDC_TT_RADIOBUTTON:
               	lpttt->lpszText = "radiobutton";
                  break;

               case IDC_TT_EDIT:
               	lpttt->lpszText = "edit";
                  break;
      		}
			}
      	return TRUE;

      case WM_COMMAND:
      	switch(LOWORD(wParam)){
         	case IDOK:
               EndDialog(hDlg, 0);
            	return TRUE;
         }
         break;
	}
   return FALSE;
}

//        
//  tooltip
//       ,
//  lpszText   LPSTR_TEXTCALLBACK ( 
//     TTN_NEEDTEXT, 
// tooltip    )
#pragma argsused
BOOL EnumChildProc(HWND hwndCtrl, LPARAM lParam){
    TOOLINFO ti;
    char szClass[20];

    //  
    GetClassName(hwndCtrl, szClass, sizeof(szClass));

    //      "static"
    if (lstrcmp(szClass, "STATIC")) {
        ti.cbSize = sizeof(TOOLINFO);
        ti.uFlags = TTF_IDISHWND; //   , 
		  // uId   ,   
        //,    
        ti.hwnd = hdlg;
        ti.uId = (UINT) hwndCtrl;
        ti.hinst = hInst;
        ti.lpszText = LPSTR_TEXTCALLBACK;

        //    tooltip
        SendMessage(hwndTT, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);
    }
    return TRUE;
}


//   ,     
// 
#pragma argsused
LRESULT CALLBACK GetMsgProc(int nCode, WPARAM wParam, LPARAM lParam)
{
    MSG *lpmsg;
    lpmsg = (MSG *)lParam;

    // nCode < 0,    
    if (nCode < 0 || !(IsChild(hdlg, lpmsg->hwnd)))
        return (CallNextHookEx(hhk, nCode, wParam, lParam));

    switch (lpmsg->message) {
        case WM_MOUSEMOVE:
        case WM_LBUTTONDOWN:
        case WM_LBUTTONUP:
        case WM_RBUTTONDOWN:
        case WM_RBUTTONUP:
        		//    tooltip
            if (hwndTT != NULL) {

                MSG msg;

                msg.lParam = lpmsg->lParam;
                msg.wParam = lpmsg->wParam;
                msg.message = lpmsg->message;
                msg.hwnd = lpmsg->hwnd;
                SendMessage(hwndTT, TTM_RELAYEVENT, 0,
                    (LPARAM) (LPMSG) &msg);
            }
            break;
        default:
            break;
    }
    //   hook-
    return (CallNextHookEx(hhk, nCode, wParam, lParam));
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Tooltip");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}


