/*
trackbar.cpp
      Trackbar

 :
   ""    ,   
Trackbar,     0  10.
    (     
)      ,  .
        
"Trackbar Demo"  ,    
.
*/

#include <windows.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "   \"\"    ,  "
				  "  Trackbar,     0  10. "
              "    (     "
              " )      "
              "  .";

BOOL CALLBACK TrackbarDialogProc(HWND, UINT, WPARAM, LPARAM);

LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

//  
char const szClassName[] = "TrackbarControl";
// 
char const szWindowTitle[] = "  : ";

HINSTANCE hInst;
int nStr = 0;
int xClientView, yClientView;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "PROC_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON,	16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

	/*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	HDC hDC;
   PAINTSTRUCT ps;
   LPCTSTR lpString = "Trackbar Demo";
   int i;

	switch (Message)
	{

      case WM_PAINT:
      	hDC = BeginPaint(hWnd, &ps);
         for (i=0; i<nStr; i++)
         	TextOut(hDC, 1, 20*i, lpString, strlen(lpString));
         EndPaint(hWnd, &ps);
         break;

      case WM_COMMAND:
      	switch(wParam){
         	case IDM_EXIT:
            	SendMessage(hWnd, WM_CLOSE, 0, 0);
               break;
            case IDM_DIALOG:
            	DialogBox((HINSTANCE)hInst, "TrackbarDialog", hWnd,
               			 (DLGPROC)TrackbarDialogProc);
               InvalidateRect(hWnd, NULL, TRUE);
       			break;
            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_trackbar);
					break;
         }
      	return 0;

		case WM_DESTROY:
			PostQuitMessage(0);
			return 0;
	}
	//      :
	return DefWindowProc(hWnd, Message, wParam, lParam);
}

#pragma argsused
BOOL CALLBACK TrackbarDialogProc(HWND hDlg, UINT Message,
										WPARAM wParam, LPARAM lParam){

 static HWND hwndTrackbar; //   Trackbar
 char lpMess[9][20] = {"TB_PAGEUP",
 							  "TB_PAGEDOWN",
		         	  	  "TB_LINEUP",
      		   	  	  "TB_LINEDOWN",
		         	  	  "TB_TOP",
      		        	  "TB_BOTTOM",
         			  	  "TB_THUMBPOSITION",
		         	  	  "TB_THUMBTRACK",
		         	  	  "TB_ENDTRACK"};
 int n;

 switch(Message){

	case WM_INITDIALOG:
		//   Trackbar
      hwndTrackbar = CreateWindow(TRACKBAR_CLASS, // 
      					"",
      					WS_CHILD|WS_VISIBLE|WS_TABSTOP|TBS_AUTOTICKS, //
                     4, 75, 300, 40,
                     hDlg,  //  
                     NULL,
                     hInst, // 
                     NULL);

      //    
      SendMessage(hwndTrackbar, TBM_SETRANGE, TRUE, MAKELONG(0, 10));

      //    nStr
      SendMessage(hwndTrackbar, TBM_SETPOS, TRUE, nStr);
      return 0;

   //      -
   //  
   case WM_HSCROLL:
      switch(LOWORD(wParam)){
      	//  <PgUp>      
         //   
      	case TB_PAGEUP:
         	n=0;
            break;
         //  <PgDn>      
         //   
         case TB_PAGEDOWN:
         	n=1;
            break;
         //  <left>  <up>
         case TB_LINEUP:
         	n=2;
            break;
         //  <right>  <down>
         case TB_LINEDOWN:
         	n=3;
            break;
         //  <Home>
         case TB_TOP:
         	n=4;
            break;
         //  <End>
         case TB_BOTTOM:
         	n=5;
            break;
         //     
         case TB_THUMBPOSITION:
         	n=6;
            break;
         //     
         case TB_THUMBTRACK:
         	n=7;
            break;
         //     
         case TB_ENDTRACK:
         	n=8;
            break;
      }
      SetDlgItemText(hDlg, IDC_MESSAGE, lpMess[n]);
      return 0;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
            //   
         	nStr = SendMessage(hwndTrackbar, TBM_GETPOS, 0, 0);
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Trackbar");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

