/*
treeview.cpp
     Tree View

 :
       ,
       0  100,  
  - ,       .
*/

#include <windows.h>
#include <stdio.h>
#include <commctrl.h>

#include "proc.h"   //    
						  //

char *lpBuf = "       "
				  ",        0 "
              " 100,     - ,   "
              "    .";

LRESULT CALLBACK WndProc
	  ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );

//  
char const szClassName[] = "TreeView";
// 
char const szWindowTitle[] = "  :  ";

HINSTANCE hInst;

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
						 LPSTR lpszCmdParam, int nCmdShow)
{
   HWND hWnd;
	WNDCLASSEX WndClass;
	MSG Msg;

	hInst = hInstance;

	/*    */
   WndClass.cbSize = sizeof(WNDCLASSEX);   // 
	WndClass.style = CS_HREDRAW | CS_VREDRAW;  //  
	WndClass.lpfnWndProc = WndProc; //    
	WndClass.cbClsExtra = 0; //  
	WndClass.cbWndExtra = 0; //  
	WndClass.hInstance = hInstance; //  
	WndClass.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(BOOK)); // 
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW); //  
	WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
	WndClass.lpszMenuName = "MIN_MENU"; //   
	WndClass.lpszClassName = szClassName; //   
   WndClass.hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(BOOK),
   										IMAGE_ICON,	16, 16, 0); // 

	/*    */
	if (!RegisterClassEx(&WndClass))
	{
		MessageBox(NULL, "Cannot register class", "Error", MB_OK);
		return 0;
	}

   //    :
   InitCommonControls();

   /*   */
	hWnd = CreateWindow(szClassName, //   
							  szWindowTitle, //  
							  WS_OVERLAPPEDWINDOW, //  
							  CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
							  CW_USEDEFAULT, CW_USEDEFAULT, // , 
							  NULL, //   
							  NULL, //  
							  hInstance, //  
							  NULL); //    

	if (!hWnd)
	{
		MessageBox(NULL, "Cannot create Window", "Error", MB_OK);
		return 0;
	}

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	/*       WM_QUIT */
	while (GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg); //     
		DispatchMessage(&Msg);  //  
	}

	return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT WINAPI WndProc (HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	static HWND hTreeViewWnd;
   RECT Rect;
   TV_INSERTSTRUCT TV_InsertStruct;
   TV_ITEM TV_Item;
   int i, j;
   char Buf[12];
   HIMAGELIST himl;
   int iImage, iSelImage, iSimpleImage, iSimpleSelImage;

	switch (Message)
	{
		case WM_CREATE:
         GetClientRect(hWnd, &Rect);

         //   Tree View
         hTreeViewWnd = CreateWindow(WC_TREEVIEW, // 
         									 "",
         									 WS_VISIBLE|WS_TABSTOP|
                                     WS_CHILD|
                                     TVS_HASLINES|TVS_HASBUTTONS|
                                     TVS_LINESATROOT, //
                                     0, 0, Rect.right, Rect.bottom,
                                     hWnd,  //  
                                     NULL,
                                     hInst, // 
                                     NULL);
         if (hTreeViewWnd == NULL) return FALSE;

         //  TV_INSERTSTRUCT,   
         //  :

         himl = ImageList_Create(GetSystemMetrics(SM_CXSMICON),
         								GetSystemMetrics(SM_CXSMICON),
                                 TRUE, 4, 1);

         iImage = ImageList_AddIcon(himl, LoadIcon(hInst, MAKEINTRESOURCE(treefull)));
         iSelImage = ImageList_AddIcon(himl, LoadIcon(hInst, MAKEINTRESOURCE(treeempty)));
         iSimpleImage = ImageList_AddIcon(himl, LoadIcon(hInst, MAKEINTRESOURCE(bookclose)));
         iSimpleSelImage = ImageList_AddIcon(himl, LoadIcon(hInst, MAKEINTRESOURCE(bookopen)));

         TreeView_SetImageList(hTreeViewWnd, himl, TVSIL_NORMAL);

         // ,     
         TV_InsertStruct.hInsertAfter = TVI_LAST;
         //    TV_Item:
         TV_Item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
         for(i=0; i<100; i+=10){
         	TV_InsertStruct.hParent = TVI_ROOT; //  
            TV_Item.pszText = itoa(i, Buf, 10); //
            TV_Item.iImage = iImage;
            TV_Item.iSelectedImage = iSelImage;
            TV_InsertStruct.item = TV_Item;  //   

            //     
            TV_InsertStruct.hParent = TreeView_InsertItem(hTreeViewWnd,
            															 &TV_InsertStruct);
            for(j=1; j<10; j++){
            	TV_Item.pszText = itoa(i+j, Buf, 10);
               TV_Item.iImage = iSimpleImage;
            	TV_Item.iSelectedImage = iSimpleSelImage;
               TV_InsertStruct.item = TV_Item;
               TreeView_InsertItem(hTreeViewWnd, &TV_InsertStruct);
            }
         }
         return 0;

      case WM_COMMAND:
      	switch(wParam){
         	case IDM_EXIT:
            	SendMessage(hWnd, WM_CLOSE, 0, 0);
               break;

            case IDM_HELPABOUT:
               DialogBox((HINSTANCE)hInst, "ABOUTBOX", hWnd,
               			 (DLGPROC)AboutDialogProc);
					break;

				case IDM_HELPCONTENTS:
            	WinHelp(hWnd, "Help.hlp", HELP_CONTEXT, (DWORD)ID_treeview);
					break;
         }
      	return 0;

      case WM_DESTROY:
         PostQuitMessage(0);
			return 0;

		default :
		//      :
			return DefWindowProc(hWnd, Message, wParam, lParam);
	}
}

#pragma argsused
BOOL CALLBACK AboutDialogProc(HWND hDlg, UINT Message, WPARAM wParam, LPARAM lParam){

 switch(Message){
	case WM_INITDIALOG:
   		SetDlgItemText(hDlg, IDC_STATIC2, "Tree View");
      	SetDlgItemText(hDlg, IDC_STATICABOUT, lpBuf);
      return TRUE;

   case WM_COMMAND:
   	switch(LOWORD(wParam)){
      	case IDOK:
         	EndDialog(hDlg, 0);
            return TRUE;
      }
      break;
 }
 return FALSE;
}

